package promo

import (
	"github.com/gin-gonic/gin"
	"github.com/perfect-panel/server/internal/logic/admin/promo"
	"github.com/perfect-panel/server/internal/svc"
	"github.com/perfect-panel/server/internal/types"
	"github.com/perfect-panel/server/pkg/result"
)

func UpdateRuleHandler(svcCtx *svc.ServiceContext) func(c *gin.Context) {
	return func(c *gin.Context) {
		var req types.UpdatePromoRuleRequest
		if err := c.ShouldBindUri(&req); err != nil {
			result.ParamErrorResult(c, err)
			return
		}
		_ = c.ShouldBind(&req)
		if err := svcCtx.Validate(&req); err != nil {
			result.ParamErrorResult(c, err)
			return
		}
		l := promo.NewUpdateRuleLogic(c.Request.Context(), svcCtx)
		resp, err := l.UpdateRule(&req)
		result.HttpResult(c, resp, err)
	}
}
